#ifdef USE_TI89
    #include "Lava.h"
    #undef KEY_UP
    #undef KEY_DOWN
    #undef KEY_RIGHT
    #undef KEY_LEFT
    #undef KEY_ESC
    #define LCD_W		160
    #define LCD_H		100//debug
#else
    #define LCD_W		160
    #define LCD_H		80
#endif


#define LIFE_MAX        300
#define	TILE_W			8
#define TILE_H			8
// ʵΪ6*10, ϱ߿8*12, Ϸɼ2, ܼΪ8*14
#define MAP_W           8
#define	MAP_H			(LCD_H/8+4)
#define X               0
#define Y               1

char ms0, Hits, Life_Update, Mode, Tick, TickMsg, Speed, Title, Cheat, Srand0;
char newForm, newCount, newWidth, newType[3], newPosX[3], newPosY[3];
char boxForm, boxCount, boxWidth, boxType[3], boxPosX[3], boxPosY[3], boxID;
char i, j, n;
char cx, cy, dly;
int Life, tmp;
int Score[7], Combo[10];
char UserKey[5], Map[MAP_W][MAP_H], Name[7][7], bmp_temp[72], buf[72];

// form = 0-1, 1-2, 2-2, 3-J3, 4-L3, 5-3, 6-3
char formLen[7] =
{
    1, 2, 2, 3, 3, 3, 3
};

char type_dxy[7][4] =
{
    0,0, 0,0,
    0,1, 0,0,
    1,0, 0,0,
    1,0, 1,1,
    1,0, 0,1,
    1,0, 2,0,
    0,1, 0,2
};

#define TYPE_BLANK  0
#define TYPE_BLOCK  6
#define TYPE_MAX    10
#define TYPE_ANIM1  10
#define TYPE_ANIM4  13
char bmp_box[][8] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,//type=0     
    0x7e, 0x83, 0xbb, 0xa3, 0xa3, 0x87, 0xff, 0x7e,//type=1     1
    0x7e, 0xd7, 0xab, 0xd7, 0xab, 0xd7, 0xff, 0x7e,//type=2     2
    0x7e, 0x83, 0x83, 0x83, 0x83, 0x87, 0xff, 0x7e,//type=3     3
    0x7e, 0x83, 0x9f, 0x9f, 0xff, 0xff, 0xff, 0x7e,//type=4     4
    0x7e, 0xc3, 0xa5, 0x99, 0x99, 0xa5, 0xc3, 0x7e,//type=5     5
    0x3c, 0x7e, 0xcf, 0xdf, 0xff, 0xff, 0x7e, 0x3c,//type=6     谭
    0x7e, 0xf9, 0xe3, 0xc7, 0xe3, 0xc7, 0x9f, 0x7e,//type=7     ͸
    0x7e, 0xa5, 0xe7, 0x81, 0x81, 0xe7, 0xa7, 0x7e,//type=8     
    0x3d, 0x76, 0xeb, 0xf7, 0xff, 0xff, 0x7e, 0x3c,//type=9     ը
    0x00, 0x00, 0x28, 0x10, 0x28, 0x14, 0x00, 0x00,//type=10    ը֡1
    0x00, 0x40, 0x1a, 0x24, 0x2c, 0x18, 0x42, 0x00,//type=11    ը֡2
    0x01, 0x5a, 0x34, 0x66, 0x6a, 0x72, 0x34, 0x82,//type=12    ը֡3
    0xb9, 0x64, 0xea, 0xde, 0xe4, 0x6c, 0xb2, 0x11 //type=13    ը֡4
};

char strRank[][4] =
{
    "1st", "2nd", "3rd"
};
char strTitle[][9] =
{
    "MagicBox",
    " Block  ",
    "Puncture",
    " Chain  ",
    "  Bomb  "
};
char strHelp[][25] =
{
    "Programming: SnoopyZZ   ",
    "Original: Yufei Pan     ",
    "PS. We are Chinese, I   ",
    "trans it into English.  ",
    "If had any mistake of   ",
    "words, I'm say sorry.   ",
    "  [How to play]", 
    "  Six different type of ",
    "box called MagicBox, and",
    "you can remove them by  ",
    "make three in any Direc-",
    "tion.",
    "  You can't remove Block",
    ", but 3 type of special ",
    "item can do it.",
    "  1. Puncture can remove",
    "a whole column of boxes.",
    "  2. Chain can remove   ",
    "all same boxes of hit.  ",
    "  3. Bomb can remove up ",
    "to 8 boxes near hit.    ",
    "  You should win high   ",
    "score by comob hits!    ",
    "  Enjoy it & good luck! "
};

char lava_GetWordMode = 0;
int GetWord(char mode)
{
    // mode
    // 0 - ENG
    // 1 - NUM
    // 2 - CHS
    // 3 - LAST
    int ch;
    mode = mode&3;
    if( mode==3 )
    {
        mode = lava_GetWordMode;
    }
    else
    {
        lava_GetWordMode = mode;
    }
    ch = getchar();
    if( mode==1 )
    {
        if(ch=='b') return '1';
        if(ch=='n') return '2';
        if(ch=='m') return '3';
        if(ch=='g') return '4';
        if(ch=='h') return '5';
        if(ch=='j') return '6';
        if(ch=='t') return '7';
        if(ch=='y') return '8';
        if(ch=='u') return '9';
    }
    return ch;
}

void SaveFile()
{
    addr fp;
    MakeDir("LavaData");
    fp = fopen("/LavaData/magicdat.dat", "w");
    if (fp == NULL)
    {
        return;
    }
    fwrite(&Score[1], 1, 12, fp);
    fwrite(&Name[1], 1, 42, fp);
    fwrite(&UserKey[0], 1, 5, fp);
    fwrite(&dly, 1, 1, fp);
    fclose(fp);
}

void LoadFile()
{
    addr fp;
    // ֵ
    for (i = 1; i < 7; i++)
    {
        strcpy(Name[i], "NC");
    }
    UserKey[0] = 23;
    UserKey[1] = 22;
    UserKey[2] = 21;
    UserKey[3] = 13;
    UserKey[4] = 20;
    dly = 0;
    // ȡļ
    fp = fopen("/LavaData/magicdat.dat", "r");
    if (fp == NULL)
    {
        return;
    }
    fseek(fp, 0, 2);
    if (ftell(fp) == 60)
    {
        fseek(fp, 0, 0);
        fread(&Score[1], 1, 12, fp);
        fread(&Name[1], 1, 42, fp);
        fread(&UserKey[0], 1, 5, fp);
        fread(&dly, 1, 1, fp);
    }
    fclose(fp);
}

void DrawDialog(int x0, int y0, int x1, int y1)
{
    Block(x0 + 2, y0 + 2, x1 + 2, y1 + 2, 1);
    Block(x0, y0, x1, y1, 0);
    Rectangle(x0, y0, x1, y1, 1);
}

void DrawForm()
{
    Rectangle(0, 0, 159, 79, 1);
    Rectangle(0, 0, 159, 17, 1);
    Block(2, 2, 157, 15, 2);
}

void num2str(int num)
{
    buf[4] = 0;
    buf[3] = num%10 + '0'; num=num/10;
    buf[2] = num%10 + '0'; num=num/10;
    buf[1] = num%10 + '0'; num=num/10;
    buf[0] = num%10 + '0';
    //sprintf(buf, "%d%d%d%d", num / 1000, num % 1000 / 100, num % 1000 % 100 / 10, num % 1000 % 100 % 10);
}

void ShowScore()
{
    DrawDialog(38, 24, 112, 53);
    if (Life < 0)
    {
        Life = 0;
        TextOut(45, 33, "Time Over!", 1);
    }
    else
    {
        TextOut(45, 33, "Game Over!", 1);
    }
    Refresh();
    Delay(500);
    getchar();
    ClearScreen();
    TextOut(50, 3, "Combo Hits", 1);
    DrawForm();
    if (Score[0] < 1)
    {
        return ;
    }
    TextOut(14, 22, "Score:", 1);
    num2str(Score[0]);
    TextOut(50, 22, buf, 1);
    for (n = 1; n < 11; n++)
    {
        if (Combo[n - 1] == 0)
        {
            break;
        }
        if (n < 8)
        {
            j = n;
        }
        else
        {
            j = n - 7;
        }
        tmp = (long)Combo[n-1] * 100 / Score[0];//˷BUG
        if (tmp > 99)
        {
            tmp = 99;
        }
        if (j < 2)
        {
            i = 1;
        }
        else
        {
            i = j & 1;
        }
        i = i*76+8;
        j = j/2*15+22;
        DrawDialog(i - 1, j - 1, i + 67, j + 13);
        if( n<10 )
        {
            buf[0] = n + '0';
            buf[1] = ':';
            buf[2] = 0;
        }
        else
        {
            buf[0] = '1';
            buf[1] = '0';
            buf[2] = ':';
            buf[3] = 0;
        }
        TextOut(i+1, j+1, buf, 1);
        buf[3] = 0;
        buf[2] = '%';
        buf[1] = tmp%10 + '0';
        buf[0] = tmp/10 + '0';
        //sprintf(buf, "%d%d%%", tmp / 10, tmp % 10);
        TextOut(i + 48, j + 1, buf, 1);
        num2str(Combo[n - 1]);
        TextOut(i + 18, j + 1, buf, 1);
    }
    Refresh();
    getchar();
}

void ShowHelp()
{
    char ch;
    n = 0;
    while (n < sizeof(strHelp)/25 )
    {
        Block(2, 20, 157, 78, 0);
        for (j = 0; j < 4; j++)
        {
            TextOut(6, j*15+20, strHelp[j + n], 1);
        }
        Refresh();
        ch = getchar();
        if (ch == 27)
        {
            return ;
        }
        if (ch == 20)
        {
            n = n - 4;
        }
        else
        {
            n = n + 4;
        }
    }
}

void ShowOption()
{
    char ch, key[5];
    n = 0;
    for (;;)
    {
        Block(2, 20, 158, 78, 0);
        TextOut(44, 31, "Set Keys ", 1);
        TextOut(44, 55, "Set Speed", 1);
        Block(43, 30+n*24, 98, 44+n*24, 2);
        Refresh();
        ch = getchar();
        if (ch < 24 && ch > 19)
        {
            n = 1-n;
        }
        if (ch == 27)
        {
            return ;
        }
        if (ch != 13)
        {
            continue;
        }
        if (n)
        {
            Block(2, 20, 158, 76, 0);
            Rectangle(44, 50, 118, 61, 1);
            TextOut(50, 30, "Set Speed:", 1);
            TextOut(44, 63, "Slow     Fast", 1);
            for (;;)
            {
                buf[1] = 0;
                buf[0] = dly + '0';
                TextOut(110, 30, buf, 1);
                Block(45, 51, 117, 60, 0);
                Rectangle(dly*7+46, 52, dly*7+53, 59, 1);
                Block(dly*7+48, 54, dly*7+51, 57, 1);
                Refresh();
                ch = getchar();
                if( ch==22 )//
                {
                    if( dly<9 )
                        dly = dly + 1;
                    else
                        dly = dly - 9;
                    continue;
                }
                if( ch==23 )//
                {
                    if( dly>0 )
                        dly = dly - 1;
                    else
                        dly = dly + 9;
                    continue;
                }
                if (ch == 27)
                {
                    break;
                }
                if (ch == 13)
                {
                    break;
                }
            }
        }
        else
        {
            Block(2, 20, 158, 76, 0);
            TextOut(25, 36, "Left:     Right:", 1);
            TextOut(25, 51, "Fall:     Pause:", 1);
            TextOut(25, 66, "Shift:", 1);
            TextOut(25, 21, "Press any key...", 1);
            for (i = 0; i < 5; i++)
            {
                j = i;
                if (i > 1)
                {
                    j = i & 1;
                }
                sprintf(buf, "%d", UserKey[i]);
                TextOut(j*60+62, i/2*15+36, buf, 1);
            }
            Refresh();
            for (i = 0; i < 5; i++)
            {
                j = i;
                if (i > 1)
                {
                    j = i & 1;
                }
                Block(j*60+61, i / 2*15+35, j*60+81, i / 2*15+48, 2);
                Refresh();
                key[i] = getchar();
                if (key[i] == 27)
                {
                    break;
                }
                Block(j*60+61, i / 2*15+35, j*60+81, i / 2*15+48, 0);
                sprintf(buf, "%d", key[i]);
                TextOut(j*60+62, i / 2*15+36, buf, 1);
            }
            if (i == 5)
            {
                DrawDialog(46, 24, 114, 53);
                TextOut(54, 27, "Use this?", 1);
                TextOut(54, 40, "  Y/N", 1);
                Refresh();
                ch = getchar();
                if (ch == 'y' || ch == 13)
                {
                    for (i = 0; i < 5; i++)
                    {
                        UserKey[i] = key[i];
                    }
                }
            }
        }
    }
}

void ShowRanking()
{
    ClearScreen();
    TextOut(32, 3, "MagicBox Ranking", 1);
    DrawForm();
    for (n = 0; n < 2; n++)
    {
        DrawDialog(13+n*82, 23, 63+n*82, 39);
        DrawDialog(4+n*80, 36, 74+n*80, 75);
        Line(13+n*82, 36, 63+n*82, 36, 0x40);
        for (i = 1; i < 4; i++)
        {
            j = i + n*3;
            TextOut(7+n*80, 26+12*i, Name[j], 1);
            num2str(Score[j]);
            TextOut(49+n*80, 26+12*i, buf, 1);
        }
    }
    TextOut(18, 26, "Classic", 1);
    TextOut(102, 26, "Timing", 1);
    Refresh();
    getchar();
}

void InputName(char x, char y)
{
    int ch;
    char _x, len;
    char mode;
    mode = 2;   //Ĭ뷨
    buf[0] = 0;
    len = 0;
    SetScreen(0);
    for (;;)
    {
        Block(x, y, x+37, y+12, 0);
        TextOut(x, y, buf, 1);
        _x = len*6 + x;
        Block(_x, y, _x+1, y+11, 1);
        Refresh();
        ch = GetWord(mode);
        mode = 3;   //ϴ뷨
        if (ch == 23 || ch == 29)
        {// /F2, ɾַ
            if (len > 0)
            {
                if (--len>0 && (buf[len]&0x80))
                {
                    --len;
                }
            }
            buf[len] = 0;
            continue;
        }
        if (ch&0x80)
        {
            if (len < 5)
            {
                buf[len++] = ch&255;
                buf[len++] = ch>>8;
                buf[len] = 0;
            }
            continue;
        }
        if (isprint(ch))
        {
            if (len < 6)
            {
                buf[len++] = ch;
                buf[len] = 0;
            }
            continue;
        }
        if (ch == 13 )
        {
            if( len>0 )
            {
                strcpy(Name[0], buf);
                return ;
            }
            ch = 27;
        }
        if (ch == 27)
        {
            strcpy(Name[0], "NoName");
            return ;
        }
        if (len == 6)
        {
            Beep();
        }
    }
}

void AddToTop()
{
    char pos;
    for (i = 3; i > 0; i--)
    {
        pos = i + Mode*3;
        if (Score[0] > Score[pos])
        {
            continue;
        }
        pos++;
        break;
    }
    if (pos < Mode*3+4)
    {
        DrawDialog(38, 24, 112, 53);
        TextOut(42, 27, "You got ", 1);
        TextOut(90, 27, strRank[i], 1);
        TextOut(42, 40, "New Ranking", 1);
        Refresh();
        for (i = Mode*3+3; i > pos; i--)
        {
            Score[i] = Score[i - 1];
            strcpy(Name[i], Name[i - 1]);
        }
        Score[pos] = Score[0];
        getchar();
        //
        DrawDialog(38, 24, 113, 53);
        TextOut(46, 27, "Your Name:", 1);
        InputName(59, 40);
        strcpy(Name[pos], Name[0]);
    }
    ShowRanking();
}

void DrawPic(char x, char y, char type)
{
    WriteBlock(x*8, y*8-24, 8, 8, 1, bmp_box[type]);
}

void DrawBox()
{
    for(n=0; n<boxCount; n++)
    {
        WriteBlock(boxPosX[n]*8, boxPosY[n]*8-24, 8, 8, 1, bmp_box[boxType[n]]);
    }
    Refresh();
}

void BoxNew()
{
    addr dxy;
    char nx, r;
    //  Cheat
    if( Cheat==1 )
    {
        if( Life>LIFE_MAX/10 )
        {
            Life = Life - LIFE_MAX/10;
            Life_Update = 2;
        }
        else
        {
            Cheat = 0;
        }
    }
    //  new form
    r = rand() & 0xff;
    if( r<0x19 || Cheat==1 )
    {
        Cheat = 0;
        newForm = 0;        // ⷽ form=0 ()
    }
    else
    if( r<0x66 )
    {
        newForm = (r&1) + 1; //  form=1,2 (, )
    }
    else
    {
        newForm = (r&3) + 3; //  form=3,4,5,6 (, ҹ, , )
    }
    // new count
    newCount = formLen[newForm];
    // new type
    if( newForm==0 )
    {
        newType[0] = r%3 + 7;// ⷽ type=7,8,9
    }
    else
    {
        r = rand() & 0xff;
        for (n = 0; n < newCount; n++)
        {
            if (r < 0xf2)
            {
                newType[n] = r%5 + 1;   // ͨ type=1,2,3,4,5
                r = r/5;
            }
            else
            {
                newType[n] = TYPE_BLOCK;// ϰ type=6
            }
        }
    }
    // form1: 
    // form5: 
    // width
    if( newForm>=2 && newForm<=4 )
    {
        newWidth = 16;
    }
    else
    if( newForm==5 )
    {
        newWidth = 24;
    }
    else
    {// form=0,1,6
        newWidth = 8;
    }
    // úѡͼƬĻȡ
    if( newForm==2 || newForm==3 || newForm==5 )
    {
        nx = 5;
    }
    else
    {
        nx = 6;
    }
    // ³ʼ
    Block(64, 0, 87, 23, 0);
    newPosX[0] = 3;
    newPosY[0] = 3;
    DrawPic(nx+newPosX[0], newPosY[0]+2, newType[0]);
    dxy = type_dxy[newForm];
    for(n=1; n<newCount; n++)
    {
        newPosX[n] = newPosX[0] + *dxy++;
        newPosY[n] = newPosY[0] - *dxy++;
        DrawPic(nx+newPosX[n], newPosY[n]+2, newType[n]);
    }
    Refresh();
}

//  ˳
void BoxShift()
{
    if( boxCount==1 || boxType[0]==TYPE_BLOCK )
    {
        return ;
    }
    tmp = boxType[0];
    if( boxCount==2 )
    {
        boxType[0] = boxType[1];
        boxType[1] = tmp;
    }
    else
    {
        boxType[0] = boxType[2];
        boxType[2] = boxType[1];
        boxType[1] = tmp;
    }
}

//  ֱ
void BoxToBottom()
{
    char x, y, y0;
    for(n=0; n<boxCount; n++)
    {
        x = boxPosX[n];
        y0 = boxPosY[n];
        for(y=y0; y<MAP_H; y++)
        {
            boxID = Map[x][y+1];
            if( boxID!=0 )
            {
                Map[x][y0] = 0;
                DrawPic(x, y0, TYPE_BLANK);
                boxPosY[n] = y;
                cy = y;
                Map[x][y] = boxType[n];
                DrawPic(x, y, boxType[n]);
                break;
            }
        }
    }
}

// dir:0 
// dir:-1
// dir:+1
void BoxMove(char dir)
{
    char x, y;
    for(n=0; n<boxCount; n++)
    {
        x = boxPosX[n];
        y = boxPosY[n];
        Map[x][y] = 0;
        DrawPic(x, y, TYPE_BLANK);
        if( dir==0 )
        {
            boxPosY[n] = y + 1;
        }
        else
        {
            boxPosX[n] = x + dir;
        }
    }
}

// δ, CheckBoxֵ
int CheckBox(char type)
{
    char mx, my, x0, y0, x1, y1;
    char hits, count;
    // Ʒ
    if (type!=0)
    {
        hits = 1; 
        // 1
        if (type == 7)
        {
            for (my=cy; my<MAP_H-1; my++)
            {
                Map[cx][my] = Map[cx][my] | 0xf0;
            }
        }
        else
        // ͬ
        if (type == 8)
        {
            Map[cx][cy] = boxID;
            for (mx=1; mx<MAP_W-1; mx++)
            {
                for (my=3; my<MAP_H-1; my++)
                {
                    if (Map[mx][my] == boxID)
                    {
                        Map[mx][my] = Map[mx][my] | 0xf0;
                    }
                }
            }
        }
        else
        // ը9
        if (type == 9)
        {
            for (mx=cx-1; mx<=cx+1; mx++)
            {
                for (my=cy-1; my<=cy+1; my++)
                {
                    if( Map[mx][my]<TYPE_MAX )
                    {
                        Map[mx][my] = Map[mx][my] | 0xf0;
                    }
                }
            }
        }
    }
    // ж3
    else
    {
        hits = 0;
        for (my = 0; my < MAP_H-1; my++)
        {
            for (mx = 1; mx < MAP_W-1; mx++)
            {
                boxID = Map[mx][my] & 0x0f;
                if (boxID==0 || boxID>=TYPE_BLOCK )
                {
                    continue;
                }
                // 
                count = 1;
                y1 = my;
                while ((Map[mx][++y1] & 0x1f) == boxID)
                {
                    count++;
                }
                if (count >= 3)
                {
                    hits++;
                    for (y0 = my; y0 < y1; y0++)
                    {
                        Map[mx][y0] = Map[mx][y0] | 0x10;
                    }
                }
                // 
                count = 1;
                x1 = mx;
                while ((Map[++x1][my] & 0x2f) == boxID)
                {
                    count++;
                }
                if (count >= 3)
                {
                    hits++;
                    for (x0 = mx; x0 < x1; x0++)
                    {
                        Map[x0][my] = Map[x0][my] | 0x20;
                    }
                }
                // б ->
                count = 1;
                x0 = mx;
                y0 = my;
                x1 = mx;
                y1 = my;
                while ((Map[++x1][++y1] & 0x4f) == boxID)
                {
                    count++;
                }
                if (count >= 3)
                {
                    hits++;
                    y0 = my;
                    for (x0 = mx; x0 < x1; x0++)
                    {
                        Map[x0][y0] = Map[x0][y0] | 0x40;
                        y0++;
                    }
                }
                // б ->
                count = 1;
                x1 = mx;
                y1 = my;
                while ((Map[--x1][++y1] & 0x8f) == boxID)
                {
                    count++;
                }
                if (count >= 3)
                {
                    hits++;
                    y0 = my;
                    for (x0 = mx; x0 > x1; x0--)
                    {
                        Map[x0][y0] = Map[x0][y0] | 0x80;
                        y0++;
                    }
                }
            }
        }
    }
    if (hits)
    {
        // ʾ
        TickMsg = 30;
        TextOut(62, 34, "Good!", 1);
        Hits = Hits + hits;
        if (Hits > 1)
        {
            sprintf(buf, "%d", Hits);
            TextOut(62, 48, buf, 1);
            TextOut(62+strlen(buf)*6, 48, "Hits", 1);
        }
        // ըЧ
        for (n = TYPE_ANIM1; n <= TYPE_ANIM4; n++)
        {
            for (mx = 1; mx < MAP_W-1; mx++)
            {
                for (my = 3; my < MAP_H-1; my++)
                {
                    if (Map[mx][my]&0xf0)
                    {
                        DrawPic(mx, my, n);
                    }
                }
            }
            Refresh();
            Delay(60);
        }
        // ƶյķ
        count = 0;
        for (mx = 1; mx < MAP_W-1; mx++)
        {
            for (my = 1; my < MAP_H-1; my++)
            {
                if (Map[mx][my]&0xf0)
                {
                    count++;
                    for (n = my; n > 0; n--)
                    {
                        Map[mx][n] = Map[mx][n - 1];
                    }
                }
            }
        }
        // ػȫ
        for (mx = 1; mx < MAP_W-1; mx++)
        {
            for (my = 3; my < MAP_H-1; my++)
            {
                DrawPic(mx, my, Map[mx][my]);
            }
        }
        Refresh();
        // »
        if( Hits>10 )
        {
            Hits = 10;//, Էһ
        }
        if( type>=7 )
        {
            count = count * 3;
        }
        Score[0] = Score[0] + count*Hits;
        Combo[Hits-1] = Combo[Hits-1] + count*Hits;
        num2str(Score[0]);
        if(buf[0]=='0') buf[0]=':';
        TextOut(132, 26, buf, 1);//ʾ
    }
    return hits;
}

// ѭ, CheckBoxֵ
void CheckRemove()
{
    Hits = 0;
    if( boxCount==1 )
    {
        CheckBox(boxType[0]);
    }
    while(CheckBox(0)!=0);
}

void CheckTimer(char mode)
{
    if (mode==0)
    {// ʱֹͣ
        ms0 = Getms();
    }
    else
    {
        if( Mode!=0 )
        {
            if( (char)(Getms()-ms0)>=128 )
            {
                ms0 = (char)(ms0 + 128);
                Life_Update++;
            }
        }
    }
}

int CheckBottom()
{
    char w0;
    w0 = boxWidth / 8;
    for (i = 0; i < w0; i++)
    {
        if (Map[cx + i][cy + 1])
        {
            return 1;
        }
    }
    return 0;
}

void CheckTitle()
{
    char title;
    if( boxType[0]<TYPE_BLOCK )
    {
        title = 0;
    }
    else
    {
        title = boxType[0] - (TYPE_BLOCK-1);
    }
    if( Title!=title )
    {
        Title = title;
        TextOut(105, 3, strTitle[Title], 1);
    }
}

int GameLoop()
{
    char update_box;
    char ch, ms;
    srand(Getms()*Srand0);
    memset(Combo, 0, sizeof(Combo));
    Score[0] = 0;
    Speed = dly;
    Title = -1;
    Life = LIFE_MAX;
    // ūͼ
    for (i = 0; i < MAP_W; i++)
    {
        for (j = 0; j < MAP_H; j++)
        {
            if (i==0 || i==MAP_W-1 || j==MAP_H-1)
            {
                Map[i][j] = TYPE_MAX;
            }
            else
            {
                Map[i][j] = 0;
            }
        }
    }
    ClearScreen();
    DrawDialog(7, 0, 56, (MAP_H-4)*8+1);
    Block(8, 0, 55, (MAP_H-4)*8, 0);
    Block(4, 0, 5, (MAP_H-4)*8-2, 1);
    DrawDialog(62, 0, 89, 25);
    Block(63, 0, 88, 24, 0);
    DrawDialog(100, 0, 157, 15);
    DrawDialog(100, 24, 157, 52);
    DrawDialog(100, 61, 157, 77);
    if (Mode==0)
    {// ͳģʽ
        TextOut(106, 64, "Time:---", 1);
    }
    else
    {// ʱģʽ
        TextOut(106, 64, "Time:300", 1);
    }
    TextOut(102, 26, "Score:000", 1);
    BoxNew();
    boxWidth = newWidth;
    for (;;)
    {
        // жǷGame Over
        for (i = 1; i < MAP_W-1; i++)
        {
            if (Map[i][2] != TYPE_BLANK)
            {
                return -1;
            }
        }
        if (Speed < 9 && Score[0] >= Speed*Speed*30)
        {
            Speed++;
        }
        strcpy(buf, "Speed:000");
        buf[8] = Speed + '0';
        TextOut(102, 39, buf, 1);
        Tick = 0;
        boxForm = newForm;
        boxCount = newCount;
        boxWidth = newWidth;
        for (n = 0; n < boxCount; n++)
        {
            boxType[n] = newType[n];
            boxPosX[n] = newPosX[n];
            boxPosY[n] = newPosY[n];
        }
        BoxNew();
        cx = boxPosX[0];
        cy = boxPosY[0] - 1;
        if (CheckBottom())
        {
            BoxToBottom();
            CheckRemove();
            continue;
        }
        cy++;
        //
        update_box = 1;
        CheckTimer(0);
        for (;;)
        {
            ms = Getms();
            CheckTitle();
            CheckTimer(1);
            if (Life_Update>=2)
            {
                Life_Update = 0;
                // ģʽ, LifeʱԼ
                if (Mode!=0)
                {
                    if(Life<0) return -1;
                    tmp = Life;
                    buf[2] = tmp%10 + '0'; tmp=tmp/10;
                    buf[1] = tmp%10 + '0'; tmp=tmp/10;
                    buf[0] = tmp%10 + '0';
                    Life--;
                }
                else
                // ͳģʽ, LifeCheat
                if (Life!=LIFE_MAX)
                {
                    buf[2] = Life/(LIFE_MAX/10) + '0';
                    buf[1] = '0';
                    buf[0] = '0';
                    TextOut(106, 64, "Life:", 1);
                }
                buf[3] = 0;
                TextOut(136, 64, buf, 1);
            }
            // ӳ"Good!"Ϣ
            if (TickMsg > 0)
            {
                if (--TickMsg == 0)
                {
                    Block(62, 34, 99, 60, 0);
                }
            }
            // ٶԶ
            if (++Tick > 20-Speed*2)
            {
                Tick = 0;
                if (CheckBottom())
                {
                    BoxToBottom();
                    CheckRemove();
                    break;
                }
                cy++;
                BoxMove(0);
                update_box = 1;
            }
            ch = Inkey();
            // ƶ
            if (ch==UserKey[0])
            {
                if (Map[cx-1][cy] == 0)
                {
                    cx--;
                    BoxMove(-1);
                    update_box = 1;
                }
            }
            else
            // ƶ
            if (ch==UserKey[1])
            {
                if (Map[boxWidth/8+cx][cy] == 0)
                {
                    cx++;
                    BoxMove(+1);
                    update_box = 1;
                }
            }
            else
            // ֱ
            if (ch==UserKey[2])
            {
                BoxToBottom();
                CheckRemove();
                break;
            }
            // ͣ
            if (ch==UserKey[3])
            {
                TextOut(62, 34, "Pause", 1);
                Refresh();
                for (;;)
                {
                    ch = getchar();
                    if (ch == UserKey[3])
                    {
                        Block(62, 34, 91, 45, 0);
                        Refresh();
                        CheckTimer(0);
                        break;
                    }
                    if (ch == 27)
                    {
                        return 0;
                    }
                }
            }
            else
            // ڲ˳
            if (ch==UserKey[4])
            {
                BoxShift();
                update_box = 1;
            }
            else
            // װ
            if (ch==25)
            {
                Cheat = 1;
                BoxNew();
            }
            else
            // ˳
            if (ch==27)
            {
                return 0;
            }
            if( update_box )
            {
                update_box = 0;
                DrawBox();
            }
            while( (char)(Getms()-ms)<34*256/1000 );
        }
    }
}

void main()
{
    int select;
    char x, y;
    char ch;
    LoadFile();
    Srand0 = Getms();
    select = 0;
    for (;;)
    {
        ClearScreen();
        TextOut(37, 3, "MagicBox V1.0", 1);
        Rectangle(0, 0, 159, 79, 1);
        Rectangle(0, 0, 159, 17, 1);
        Block(2, 2, 157, 15, 2);
        TextOut(25, 24, "Classic   Timing  ", 1);
        TextOut(25, 42, "Ranking   Option  ", 1);
        TextOut(25, 60, "Help      Bye-bye ", 1);
        x = (select&1)*60 + 24;
        y = (select/2)*18 + 23;
        Block(x, y, x+51, y+13, 2);
        Refresh();
        ch = getchar();
        if(ch==20) select=select-2; else
        if(ch==21) select=select+2; else
        if(ch==22) select=select+1; else
        if(ch==23) select=select-1;
        //
        if(select<0) select=select+6; else
        if(select>5) select=select-6;
        //
        if (ch == 27)
        {
            break;
        }
        if (ch != 13)
        {
            continue;
        }
        if (select <= 1)
        {
            Mode = select;
            if (GameLoop())
            {
                ShowScore();
                AddToTop();
            }
        }
        if(select==2) { ShowRanking(); continue; }
        if(select==3) { ShowOption(); continue; }
        if(select==4) { ShowHelp(); continue; }
        if(select==5) { SaveFile(); break; }
    }
}
